use32
  org 0x0
  db 'MENUET01' ;.    8 
  dd 0x1
  dd start
  dd i_end ;  
  dd mem
  dd stacktop
  dd 0x0,0x0

include 'macros.inc'
include 'strlen.inc'

MB_MAX_BUT equ 5 ;max count buttons
CHAR_WIDTH equ 6
MB_BUT_OTY_1 equ  5
MB_BUT_OTX_1 equ  5 ;[<-?->Caption.....]
MB_BUT_OTX_2 equ 10 ;[<-?->Caption<-?->]
MB_BUT_OTX_3 equ 15 ;[<-?->Caption<-?->]<-?->
MB_TEXT_OFFSET equ 2
MB_MAX_BUF_LEN equ 512

start:
  mov eax,48
  mov ebx,3
  mov ecx,sc
  mov edx,sizeof.system_colors
  mcall

  mov eax,40
  mov ebx,0x67 ;  
  mcall

  mcall 60,1,buf_ipc,MB_MAX_BUF_LEN
  call InitMsgBox

red_win:
  mov eax,12
  mov ebx,1
  mcall

  xor eax,eax
  mov ebx,35*65536+300
  mov ecx,35*65536+100
  mov edx,[sc.work]
  or  edx,0x33000000
  mov edi,msgbox_1+MB_TEXT_OFFSET ;Caption
  mcall

  mcall 9,procinfo,-1
  mov eax,[procinfo.client_box.width]
  sub eax,[but_width]
  shr eax,1
  ;mov eax,[but_width] ;???
  add eax,MB_BUT_OTX_1
  mov [ot_left],eax


  mov eax,4 ;ᮢ ⥪
  mov bx,MB_BUT_OTX_1
  shl ebx,16
  mov bx,MB_BUT_OTY_1
  mov ecx,[sc.work_text]
  mov edx,[txtMsg]

  @@:
    mov esi,edx
    call strlen
    call linlen

    cmp eax,0
    je @f

    mov esi,eax
    push eax
      mov eax,4
      int 0x40
    pop eax

    add edx,eax
    cmp byte[edx],0
    je @f
    inc edx

    add ebx,10 ; move <--y-->
    jmp @b
  @@:

  mov ebx,[ot_left]
  shl ebx,16
  mov bx,word[ot_top]
  add bx,MB_BUT_OTY_1
  mov ecx,[sc.work_button_text]

  ; Buttons ...
  push edi
  mov edi,txtBut
  mov edx,[edi]

  @@:
    ;eax = len button caption text
    mov esi,edx
    call strlen

    cmp eax,0
    je @f

    ;button
    push eax ebx ecx edx
      imul eax,CHAR_WIDTH
      add eax,MB_BUT_OTX_2

      mov cx,bx
      sub cx,MB_BUT_OTY_1
      shl ecx,16
      mov cx,20
      ror ebx,16
      sub bx,MB_BUT_OTX_1
      ror ebx,16
      mov bx,ax
      mov edx,5
      mov esi,[sc.work_button]
      mov eax,8
      int 0x40
    pop edx ecx ebx eax

    ;caption
    mov esi,eax
    mov eax,4
    int 0x40

    add edi,4
    cmp edi,endBut
    jge @f
    mov edx,[edi]

    push bx
    ror ebx,16
      imul esi,CHAR_WIDTH
      add esi,MB_BUT_OTX_3
      add ebx,esi ; ...
    ror ebx,16
    pop bx

    jmp @b
  @@:
  pop edi

  mov eax,12
  mov ebx,2
  mcall

still:
  mov eax,10
  mcall

  cmp al,1 ;.  
  jz red_win
  cmp al,2
  jz key
  cmp al,3
  jz button
  cmp al,7
  je get_ipc

  jmp still

key:
  mcall 2
  cmp ah,13
  je close
  jmp still

button:
  mcall 17 ;  ⮩ 
  cmp ah,5
  je close
  cmp ah,1
  jne still
close:
  mcall -1 ;室  ணࠬ

get_ipc:
  ;buf_ipc,msgbox_1,MB_MAX_BUF_LEN
  mov esi, buf_ipc
  mov edi, msgbox_1
  mov ecx, [esi+4]
  add esi,8
  rep movsb	;copy info from IPC buffer

  call InitMsgBox
  jmp red_win

InitMsgBox:
  push eax ebx ecx esi
  mov esi,msgbox_1+MB_TEXT_OFFSET
  call strlen
  inc esi ;add terminated zero
  add esi,eax ;add len of caption
  mov [txtMsg],esi

  ; Buttons 1...MB_MAX_BUT
  mov ebx,txtBut
  mov cx,MB_MAX_BUT
  @@:
    call strlen
    add esi,eax ;add len of caption
    inc esi ;add terminated zero

    mov dword[ebx],esi
    cmp byte[esi],0
    je @f
    add ebx,4
  loop @b
  @@:

  ;--- calc button top ---
  mov eax,1
  mov ebx,[txtMsg]
  @@:
    inc ebx
    cmp byte[ebx],0
    je @f
    cmp byte[ebx],13
    jne @b
    inc eax
    jmp @b
  @@:
  imul eax,10
  add eax,2*MB_BUT_OTY_1
  mov [ot_top],eax

  ;--- calc button width ---
  xor ebx,ebx
  xor ecx,ecx
  mov esi,[txtBut]

  @@:
    cmp byte[esi],0
    je @f
    inc ecx
    call strlen
    add esi,eax;4
    inc esi
    add ebx,eax
    jmp @b
  @@:

  imul ebx,CHAR_WIDTH
  imul ecx,MB_BUT_OTX_3
  add ebx,ecx
  add ebx,MB_BUT_OTX_2
  sub ebx,MB_BUT_OTX_3
  mov [but_width],ebx

  pop esi ecx ebx eax
  ret

;--- data ---
  txtMsg dd 0
  txtBut rd MB_MAX_BUT
  endBut:
  ot_left dd 0
  ot_top dd 0
  but_width dd 0
  sc system_colors

msgbox_1:
  dw 0
  db 'MsgBox',0 ;+2 = +MB_TEXT_OFFSET
  db 'Some text',0
  db 'Ok',0 ;button1
  db 0
.mb_end:
rb MB_MAX_BUF_LEN

i_end:
  procinfo process_information
  buf_ipc rb MB_MAX_BUF_LEN
stacktop:
mem: